* **********************************************************************
* Katrin Auspurg & Thomas Hinz 
* Accompanying material for: Factorial Survey Experiments.
* SAGE,  Series: Quantitative Applications in the Social Sciences No. 175, 
* Thousand Oaks, CA: SAGE
*
* SAS JOB TP PROUDUCE A D-EFFICIENT SAMPLE 
* (fairness of earnings example: 
* 120 vignettes, with orthogonalization of some interaction terms/Resolution IV design)
*************************************************************************

// #1) Installation of Macros 

* Bevor running the program, you have to install the macros written by Warren Kuhfeld:  
* %mktruns, %mktex, %mktblock. See Kuhfeld 2010 or the SAS websites for details. 


*************************************************************************
// #2  Specify working directory (Library) *

* PLEASE CHANGE THE LIBRARY RESP. WORKING DIRECTORY!!! (LIBNAME "working directory" ); 

LIBNAME VIGSAS "C:\Users\katrin.auspurg\Documents\SAS\VIGSAS";


*************************************************************************
// #3 Definition of implausible and illogical combinations
* see 1_earningsexample.pdf for details;  

%macro impl; 
	bad = 	

(x6 = 1  & x7 = 2) |
(x5 = 8  & x3 = 1) |
(x5 = 10 & x3 < 3) |
(x5 = 1  & x8 > 6) |
(x5 = 2  & x8 > 7) | 
(x5 = 3  & x8 > 7) | 
(x5 = 4  & x8 > 8) | 
(x5 = 5  & x8 > 8) | 
(x5 = 6  & x8 > 8) | 
(x5 = 8  & x8 < 3) | 
(x5 = 9  & x8 < 5) |
(x5 = 10 & x8 < 5)  

	%mend; 


*************************************************************************
// #4 Optional: You may estimate a minimum number of vignette cases;

%mktruns (2 8 3 6 10 2 2 10); 


*************************************************************************
// #5 Generation of a D-efficient design: 
* 120 vignettes under the assumption of interactions and implausible cases
* for details on the interactions see 1_earningsexample.pdf; 

%mktex (2 8 3 6 10 2 2 10, restrictions = impl, interact=
x1*x8 x1*x4 x5*x6, n=120, options = resrep, seed = 815); 


*************************************************************************
// #6 Blocking to decks: 
* 12 Decks  10 vignettes (using the last fractionalized sample that was generated);

%mktblock (nblocks = 12);


*************************************************************************
// #7 Data export
* you might export the blocked data in your library to another program, like Stata.  
* Right click on the dataset ? follow the instructions. 
* When exporting the data to a Stata format we renamed them to fractionalized120.dta. 
* Keep in any case the D-efficiency values before exiting SAS!
